#ifndef _CAMERA_H_
#define _CAMERA_H_
#define CAM_UP 10.0
#define CAM_DOWN -10.0
#define CAM_LEFT -10.0
#define CAM_RIGHT 10.0

#include <gl/glut.h>
#include <math.h>

typedef struct
{
    float x;
    float y;
    float z;
} Ponto3D;

class Camera
{
    private:
        Ponto3D camera;
        Ponto3D foco;
        Ponto3D view;  
        bool nzero(double val);
        
    public:      
        Camera();
        Camera(Ponto3D camera, Ponto3D foco, Ponto3D view);
        void Azimuth(double ang);
        void Elevation(double ang);
        void Yaw(double ang);
        void Pitch(double ang);
        void Roll(double ang);
        void Translate(double tx, double ty, double tz);
        void AtualizarPosicao();        
        void moveUp();
        void moveDown();
        void moveLeft();
        void moveRight();
        void moveFront();
        void moveBack();
};

#endif
